/* --------------------------------------------------------------------  */
/*                          CALCULIX                                     */
/*                   - GRAPHICAL INTERFACE -                             */
/*                                                                       */
/*     A 3-dimensional pre- and post-processor for finite elements       */
/*              Copyright (C) 1996 Klaus Wittig                          */
/*                                                                       */
/*     This program is free software; you can redistribute it and/or     */
/*     modify it under the terms of the GNU General Public License as    */
/*     published by the Free Software Foundation; version 2 of           */
/*     the License.                                                      */
/*                                                                       */
/*     This program is distributed in the hope that it will be useful,   */
/*     but WITHOUT ANY WARRANTY; without even the implied warranty of    */ 
/*     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the      */
/*     GNU General Public License for more details.                      */
/*                                                                       */
/*     You should have received a copy of the GNU General Public License */
/*     along with this program; if not, write to the Free Software       */
/*     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.         */
/* --------------------------------------------------------------------  */

/*
TODO
*/

#include <cgx.h>

#define     TEST            0


extern unsigned char  printFlag;                   /* printf 1:on 0:off */
extern unsigned char  buffer[MAX_LINE_LENGTH]; 
extern int       elemGroupNr;

extern int   basCol[3];                        /* color indexes due to basic colormap: 0=bl. 1=w 2=gy */
extern int   foregrndcol, backgrndcol;          /* default fore- and background color */

extern Scale     scale[1];
extern float     *value_n;
extern Summen    anz[1];
extern Nodes     *node;
extern Elements  *elem;
extern Datasets *lcase;
extern CQuad4    *surf4;
extern CTri3     *surf3;
extern CHexa8    *surf8;
extern CBeam     *cbeam;
extern CBeam3    *cbeam3;
extern CTri3     *ctri3;
extern CTri6     *ctri6;
extern CQuad4    *cquad4;
extern CHexa8    *cquad8;
extern CHexa8    *chexa8;
extern CHexa20   *chexa20;

extern Alias     *alias;
extern Sets      *set;
extern Points    *point;
extern Lines     *line;
extern Lcmb      *lcmb;
extern Gsur      *surf;
extern Gbod      *body;
extern Nurbs     *nurbs;
extern SumGeo    anzGeo[1];

/* for CFD-meshing */
extern int       anz_cfdSurfs;
extern CfdSurf   *cfdSurf;

/* additional entities from setFunktions */
extern Elements  *e_enqire;     /* feld in dem e_enqire[elem[i].nr].xx abgelegt ist, statt elem[i].xx */
extern SpecialSet specialset[1];

/* data */
extern int       num_etype[13];
extern int       num_stype[13];
extern int       numEdges;
extern int       anz_normalen;
extern int       num_onod;          /* nr-of-original-nodes (nodes from input-file) */
extern int       num_olc;          /* nr-of-original-loadcases (lc from input-file) */
extern int       *colNr;
extern unsigned char  cullFlag;

/* prepares vectors pointing from the center of the element-face (like a tape in a storm)*/
/* the lengt is proportional to the value of the vector */
/* lc Dataset */
/* ne number of entities */
/* *e entities */
/* v_factor scale factor for the vectors */
void drawSurfaces_vector( int lc, int ne, int *e, float v_factor)
{
  int i,j,k,n;
  float p1[3], p2[3], v2[3];

#if TEST
  printf ("in drawSurfaces_vector\n");
#endif 


  glLineWidth(1);
  glPointSize (2);

  if (num_stype[7])
  {
    if(cullFlag) glEnable ( GL_CULL_FACE );
    n=3;
    for (i=0; i<num_stype[7]; i++ )
    {
      if(surf3[i].mat ==1) if((surf3[i].group == elemGroupNr) || (elemGroupNr == -1) )
      {
        /* calculate the start and end-point of the vector */
        for(j=0; j<n; j++)
        {
          if(node[surf3[i].nod[j]].pflag!=1)
          {
            for(k=0; k<3; k++) v2[k]=0.;
            for(k=0; k<ne; k++) v2[k]+=lcase[lc].dat[e[k]][surf3[i].nod[j]];
            p1[0]=node[surf3[i].nod[j]].nx-(v2[0]*v_factor);  
            p1[1]=node[surf3[i].nod[j]].ny-(v2[1]*v_factor);  
            p1[2]=node[surf3[i].nod[j]].nz-(v2[2]*v_factor);  
            p2[0]=node[surf3[i].nod[j]].nx+(v2[0]*v_factor);  
            p2[1]=node[surf3[i].nod[j]].ny+(v2[1]*v_factor);  
            p2[2]=node[surf3[i].nod[j]].nz+(v2[2]*v_factor);  
  
            glBegin ( GL_LINES );
#if RGB_MODE
            glColor3f( 0.,0.,0. );
#else
            glIndexi( basCol[foregrndcol] );
#endif
            glVertex3fv ( p1 );
            glVertex3fv ( p2 );
            glEnd();
            glBegin ( GL_POINTS );
            glVertex3fv ( p2 );
            glEnd();
          }
        }
      }
    }
  }
  if (num_stype[9])
  {
    if(cullFlag) glEnable ( GL_CULL_FACE );
    n=4;
    for (i=0; i<num_stype[9]; i++ )
    {
      if(surf4[i].mat <1) if((surf4[i].group == elemGroupNr) || (elemGroupNr == -1) )
      {
        /* calculate the start and end-point of the vector */
        for(j=0; j<n; j++)
        {
          for(k=0; k<3; k++) v2[k]=0.;
          for(k=0; k<ne; k++) v2[k]+=lcase[lc].dat[e[k]][surf4[i].nod[j]];
          p1[0]=node[surf4[i].nod[j]].nx-(v2[0]*v_factor);  
          p1[1]=node[surf4[i].nod[j]].ny-(v2[1]*v_factor);  
          p1[2]=node[surf4[i].nod[j]].nz-(v2[2]*v_factor);  
          p2[0]=node[surf4[i].nod[j]].nx+(v2[0]*v_factor);  
          p2[1]=node[surf4[i].nod[j]].ny+(v2[1]*v_factor);  
          p2[2]=node[surf4[i].nod[j]].nz+(v2[2]*v_factor);  

          glBegin ( GL_LINES );
#if RGB_MODE
          glColor3f( 0.,0.,0. );
#else
          glIndexi( basCol[foregrndcol] );
#endif
          glVertex3fv ( p1 );
          glVertex3fv ( p2 );
          glEnd();
          glBegin ( GL_POINTS );
          glVertex3fv ( p2 );
          glEnd();
        }
      }
    }
  }
  if (num_etype[9])
  {
    n=4;
    for (i=0; i<num_etype[9]; i++ )
    {
      if( (cquad4[i].group == elemGroupNr) || (elemGroupNr == -1) )
      {
        /* calculate the start and end-point of the vector */
        for(j=0; j<n; j++)
        {
          for(k=0; k<3; k++) v2[k]=0.;
          for(k=0; k<ne; k++) v2[k]+=lcase[lc].dat[e[k]][cquad4[i].nod[j]];
          p1[0]=node[cquad4[i].nod[j]].nx-(v2[0]*v_factor);  
          p1[1]=node[cquad4[i].nod[j]].ny-(v2[1]*v_factor);  
          p1[2]=node[cquad4[i].nod[j]].nz-(v2[2]*v_factor);  
          p2[0]=node[cquad4[i].nod[j]].nx+(v2[0]*v_factor);  
          p2[1]=node[cquad4[i].nod[j]].ny+(v2[1]*v_factor);  
          p2[2]=node[cquad4[i].nod[j]].nz+(v2[2]*v_factor);  

          glBegin ( GL_LINES );
#if RGB_MODE
          glColor3f( 0.,0.,0. );
#else
          glIndexi( basCol[foregrndcol] );
#endif
          glVertex3fv ( p1 );
          glVertex3fv ( p2 );
          glEnd();
          glBegin ( GL_POINTS );
          glVertex3fv ( p2 );
          glEnd();
        }
      }
    }
  }
}


void drawElements_vector( int lc, int ne, int *e, float v_factor)
{
  int i,j,k,n;
  float v2[3];

#if TEST
  printf ("in drawSurfaces_vector\n");
#endif 


  glLineWidth(1);
  glPointSize (2);

  if (num_etype[1])
  {
    n=8;
    for (i=0; i<num_etype[1]; i++ )
    {
      if( (chexa8[i].group == elemGroupNr) || (elemGroupNr == -1) )
      {
        /* calculate the start and end-point of the vector */
        for(j=0; j<n; j++)
        {
          for(k=0; k<3; k++) v2[k]=0.;
          for(k=0; k<ne; k++) v2[k]+=lcase[lc].dat[e[k]][chexa8[i].nod[j]];
          v2[0]=node[chexa8[i].nod[j]].nx+(v2[0]*v_factor);  
          v2[1]=node[chexa8[i].nod[j]].ny+(v2[1]*v_factor);  
          v2[2]=node[chexa8[i].nod[j]].nz+(v2[2]*v_factor);  

          glBegin ( GL_LINES );
#if RGB_MODE
          glColor3f( 0.,0.,0. );
#else
          glIndexi( basCol[foregrndcol] );
#endif
          glVertex3fv ( &node[chexa8[i].nod[j]].nx );
          glVertex3fv ( v2 );
          glEnd();
          glBegin ( GL_POINTS );
          glVertex3fv ( &node[chexa8[i].nod[j]].nx );
          glEnd();
        }
      }
    }
  }
  if (num_etype[4])
  {
    n=20;
    for (i=0; i<num_etype[4]; i++ )
    {
      if( (chexa20[i].group == elemGroupNr) || (elemGroupNr == -1) )
      {
        /* calculate the start and end-point of the vector */
        for(j=0; j<n; j++)
        {
          for(k=0; k<3; k++) v2[k]=0.;
          for(k=0; k<ne; k++) v2[k]+=lcase[lc].dat[e[k]][chexa20[i].nod[j]];
          v2[0]=node[chexa20[i].nod[j]].nx+(v2[0]*v_factor);  
          v2[1]=node[chexa20[i].nod[j]].ny+(v2[1]*v_factor);  
          v2[2]=node[chexa20[i].nod[j]].nz+(v2[2]*v_factor);  

          glBegin ( GL_LINES );
#if RGB_MODE
          glColor3f( 0.,0.,0. );
#else
          glIndexi( basCol[foregrndcol] );
#endif
          glVertex3fv ( &node[chexa20[i].nod[j]].nx );
          glVertex3fv ( v2 );
          glEnd();
          glBegin ( GL_POINTS );
          glVertex3fv ( &node[chexa20[i].nod[j]].nx );
          glEnd();
        }
      }
    }
  }
  if (num_etype[9])
  {
    n=4;
    for (i=0; i<num_etype[9]; i++ )
    {
      if( (cquad4[i].group == elemGroupNr) || (elemGroupNr == -1) )
      {
        /* calculate the start and end-point of the vector */
        for(j=0; j<n; j++)
        {
          for(k=0; k<3; k++) v2[k]=0.;
          for(k=0; k<ne; k++) v2[k]+=lcase[lc].dat[e[k]][cquad4[i].nod[j]];
          v2[0]=node[cquad4[i].nod[j]].nx+(v2[0]*v_factor);  
          v2[1]=node[cquad4[i].nod[j]].ny+(v2[1]*v_factor);  
          v2[2]=node[cquad4[i].nod[j]].nz+(v2[2]*v_factor);  

          glBegin ( GL_LINES );
#if RGB_MODE
          glColor3f( 0.,0.,0. );
#else
          glIndexi( basCol[foregrndcol] );
#endif
          glVertex3fv ( &node[cquad4[i].nod[j]].nx );
          glVertex3fv ( v2 );
          glEnd();
          glBegin ( GL_POINTS );
          glVertex3fv ( &node[cquad4[i].nod[j]].nx );
          glEnd();
        }
      }
    }
  }
}
