
#include <cgx.h>



#define     MY_COLORS       0

/* color model used with rgb and index mode */
void define_rgb(float v, float *r, float *g, float *b)
{
   /* v,r,g,b == 0->1 */

#if MY_COLORS
        *r = v;
        *g = cos( (v-0.5) * 3.1415 );
        *b = 1. - v;
#else
        if ( v < 0.1 )       *r = .5 - v*1./0.2;
        else if ( v < 0.5 )  *r = 0. ;
        else if ( v < 0.9 )  *r=  (v-.5)*1./0.4 ;
        else                 *r= 1. ;

        if ( v < 0.1 )       *r = .5 - v*1./0.2;
        else if ( v < 0.5 )  *r = 0. ;
        else if ( v < 0.8 )  *r=  (v-.5)*1./0.3 ;
        else                 *r= 1. - (v-.8)*1./0.4 ;

        if ( v < 0.1 )       *r = .5 - v*1./0.2;
        else if ( v < 0.5 )  *r = 0. ;
        else if ( v < 0.8 )  *r=  (v-.5)*1./0.3 ;
        else if ( v < 0.90 )  *r=  1. ;
        else                 *r=  1. - (v-0.90)*1./0.4 ;


        if ( v < 0.1 )
          *g = 0.;
        else if ( v < 0.3 )  *g = (v-.1) * 1./0.2;
        else if ( v < 0.5 )  *g = 1. - (v-.3) * 1./0.4;
        else if ( v < 0.9 )  *g = .5 + (v-.5) * 1./0.8;
        else                 *g = 1. - (v-.9) * 1./0.1;

        if ( v < 0.1 )
          *g = 0.;
        else if ( v < 0.3 )  *g = (v-.1) * 1./0.2;
        else if ( v < 0.5 )  *g = 1. - (v-.3) * 1./0.4;
        else if ( v < 0.8 )  *g = .5 + (v-.5) * 1./0.6;
        else if ( v < 0.9 )  *g = 1. - (v-.8) * 1./0.1;
        else                 *g = 0.;

        if ( v < 0.1 )
          *g = 0.;
        else if ( v < 0.3 )  *g = (v-.1) * 1./0.2;
        else if ( v < 0.5 )  *g = 1. - (v-.3) * 1./0.4;
        else if ( v < 0.8 )  *g = .5 + (v-.5) * 1./0.6;
        else   *g = 1. - (v-.8) * 1./0.2;


        if ( v < 0.5 )  *b = 1. - (v) * 1./0.5;
        else if ( v < 0.9 )  *b = 0.;
        else *b = (v-.9)*1./0.1;

        if ( v < 0.5 )  *b = 1. - (v) * 1./0.5;
        else *b = 0;
#endif
}


/* schreibt einen Text (x,y,z linkes unteres Eck)  */
void text(float x, float y, float z,unsigned char *msg)
{
  glRasterPos3f(x, y, z);
  while (*msg) {
    glutBitmapCharacter(GLUT_FONT, *msg);
    msg++;
  }
}


/* scala verbindet Farben mit Zahlenwerten (rgb-mode)*/
/* kb, kh Kaestchenhoehe und Breite                  */
/* dx, dy  Ursprung der Scala (linkes unteres Eck)   */
/* divisions anzahl der Kaestchen                    */
void scala( float dx, float dy, int divisions, float bmin, float bmax, float *col)
{
  register int  j, i;
  float r, g, b, df, f;
  static unsigned char string[13];
  float     kb, kh;

  df = (bmax-bmin)/divisions;
  f  = bmin;

  kh= 1.0/divisions*1.5;
  kb= 1.0/20.;


  for (i=0; i<divisions; i++)
  {
    glBegin ( GL_POLYGON );
      define_rgb( (f-bmin)/(bmax-bmin), &r,&g,&b);
      glColor3f ( r, g, b );
      glVertex2f ( dx-kb*0., dy+kh*0. );
      glVertex2f ( dx-kb*1., dy+kh*0. );
      define_rgb( (f+df-bmin)/(bmax-bmin), &r,&g,&b);
      glColor3f ( r, g, b );
      glVertex2f ( dx-kb*1., dy+kh*1. );
      glVertex2f ( dx-kb*0., dy+kh*1. );
    glEnd();

    sprintf ( string, "%8.2e ", f);
    glColor3fv ( col );
    glRasterPos2f( (dx+kb*0.2), dy-kh*0.1 );
    for ( j=0; j<9; j++) {
      glutBitmapCharacter(GLUT_FONT, string[j]);
    }
    dy+=kh;
    f+=df;
  }
  sprintf ( string, "%8.2e ", f);
  glColor3fv ( col );
  glRasterPos2f( (dx+kb*0.2), dy-kh*0.1 );
  for ( j=0; j<9; j++) {
    glutBitmapCharacter(GLUT_FONT, string[j]);
  }
}


/* scala verbindet Farben mit Zahlenwerten (rgb-mode)*/
/* kb, kh Kaestchenhoehe und Breite                  */
/* dx, dy  Ursprung der Scala (linkes unteres Eck)   */
/* divisions anzahl der Kaestchen                    */
void scala_rgb( float dx, float dy, int divisions, float bmin, float bmax, float *col)
{
  register int  j, i;
  float r, g, b, df, f, buf;
  static unsigned char string[13];
  float     kb, kh;

  df = (bmax-bmin)/divisions;
  buf=df*0.5;
  f  = bmin;

  kh= 1.0/divisions*1.5;
  kb= 1.0/20.;


  for (i=0; i<divisions; i++)
  {
    define_rgb( (f+buf-bmin)/(bmax-bmin), &r,&g,&b);
    glColor3f ( r, g, b );
    glBegin ( GL_POLYGON );
      glVertex2f ( dx-kb*0., dy+kh*0. );
      glVertex2f ( dx-kb*1., dy+kh*0. );
      glVertex2f ( dx-kb*1., dy+kh*1. );
      glVertex2f ( dx-kb*0., dy+kh*1. );
    glEnd();

    sprintf ( string, "%8.2e ", f);
    glColor3fv ( col );
    glRasterPos2f( (dx+kb*0.2), dy-kh*0.1 );
    for ( j=0; j<9; j++) {
      glutBitmapCharacter(GLUT_FONT, string[j]);
    }
    dy+=kh;
    f+=df;
  }
  sprintf ( string, "%8.2e ", f);
  glColor3fv ( col );
  glRasterPos2f( (dx+kb*0.2), dy-kh*0.1 );
  for ( j=0; j<9; j++) {
    glutBitmapCharacter(GLUT_FONT, string[j]);
  }
}


/* scalai verbindet Farben mit Zahlenwerten         */
/* kb, kh Kaestchenhoehe und Breite                */
/* dx, dy  Ursprung der Scala (linkes unteres Eck) */
/* divisions anzahl der Kaestchen                  */
void scala_indx( float dx, float dy, int divisions, float bmin, float bmax, int offset, int col)
{
  register int j, i;
  float     df, f;
  static unsigned char string[13];
  float     kb, kh;

  df = (bmax-bmin)/(divisions);
  f  = bmin;

  kh= 1.0/divisions*1.5;
  kb= 1.0/20.;

  for (i=0; i<divisions; i++)
  {
    glIndexi ( offset+i );
    glBegin ( GL_POLYGON );
      glVertex2f ( dx-kb*0., dy+kh*0. );
      glVertex2f ( dx-kb*1., dy+kh*0. );
      glVertex2f ( dx-kb*1., dy+kh*1. );
      glVertex2f ( dx-kb*0., dy+kh*1. );
    glEnd();

    sprintf ( string, "%8.2e ", f);
    glIndexi  ( col );
    glRasterPos2f( (dx+kb*0.2), dy-kh*0.1 );
    for ( j=0; j<9; j++) {
      glutBitmapCharacter(GLUT_FONT, string[j]);
    }
    dy+=kh;
    f+=df;
  }
  sprintf ( string, "%8.2e ", f);
  glIndexi  ( col );
  glRasterPos2f( (dx+kb*0.2), dy-kh*0.1 );
  for ( j=0; j<9; j++) {
    glutBitmapCharacter(GLUT_FONT, string[j]);
  }
}

/* Button liefert 1 wenn maus im Button, sonst 0  */
/* dx,dy    Ursprung des Buttons (linkes unteres Eck)  */
/* bh, bb   Hoehe, Breite des Buttons  */
/* mx, my   Mauskoordinaten  */
int button(float dx, float dy, unsigned char *msg, float mx, float my)
{
    register int   i, n;
    float bh, bb;

    i=0;
    bb=bh=0.05;

    while (*msg) {i++; msg++; }
    bb+=0.025*i;
    msg-=i;



    if ((mx > dx+bb*0.) & (mx < dx+bb*1.) & (my > dy+bh*0.) & (my < dy+bh*1.))
      {
      glColor3f ( 1., 0.0, 0.0 );
      glBegin ( GL_POLYGON );
        glVertex2f ( dx+bb*0., dy+bh*0. );
        glVertex2f ( dx+bb*1., dy+bh*0. );
        glVertex2f ( dx+bb*1., dy+bh*1. );
        glVertex2f ( dx+bb*0., dy+bh*1. );
      glEnd();
      glColor3f ( 0., 0., 0. );
      glRasterPos2f((dx+bh*0.3), (dy+bh*0.2));
      for (n=0; n<i; n++)
        glutBitmapCharacter(GLUT_FONT, msg[n]);
      glBegin ( GL_LINE_LOOP );
        glVertex2f ( dx+bb*0., dy+bh*0. );
        glVertex2f ( dx+bb*1., dy+bh*0. );
        glVertex2f ( dx+bb*1., dy+bh*1. );
        glVertex2f ( dx+bb*0., dy+bh*1. );
      glEnd();
      return (1);
      }
    else
      {
      glColor3f ( 0.7, 0.7, 0.7 );
      glBegin ( GL_POLYGON );
        glVertex2f ( dx+bb*0., dy+bh*0. );
        glVertex2f ( dx+bb*1., dy+bh*0. );
        glVertex2f ( dx+bb*1., dy+bh*1. );
        glVertex2f ( dx+bb*0., dy+bh*1. );
      glEnd();
      glColor3f ( 0., 0., 0. );
      glRasterPos2f((dx+bh*0.3), (dy+bh*0.2));
      for (n=0; n<i; n++)
        glutBitmapCharacter(GLUT_FONT, msg[n]);
      glBegin ( GL_LINE_LOOP );
        glVertex2f ( dx+bb*0., dy+bh*0. );
        glVertex2f ( dx+bb*1., dy+bh*0. );
        glVertex2f ( dx+bb*1., dy+bh*1. );
        glVertex2f ( dx+bb*0., dy+bh*1. );
      glEnd();
      return(0);
      }
}


/* Plaziert farbige Punkte  */
void polymark ( int n, float *col_r, float *col_g, float *col_b, float *x,
 float *y, float *z )
{
  GLint mode;
  int i;

  glGetIntegerv(GL_RENDER_MODE, &mode);

  if (mode == GL_RENDER)
    {
    for (i=1; i<=n; i++ )
      {
      glBegin ( GL_POINTS );
       glColor3f ( col_r[i], col_g[i], col_b[i] );
       glVertex3f ( x[i], y[i], z[i] );
      glEnd();
      }
    }
  if (mode == GL_SELECT)
    {
    for (i=1; i<=n; i++ )
      {
      glLoadName(i);
      glBegin ( GL_POINTS );
       glColor3f ( col_r[i], col_g[i], col_b[i] );
       glVertex3f ( x[i], y[i], z[i] );
      glEnd();
      }
    }
}



