
#include <extUtil.h>

int write2aba( unsigned char *datout, Summen *anz, Nodes *node, Elements *elem, Datasets *lcase )
{
  FILE *handle1, *handle2;
  int  i,j, lc;

  /* Open the files and check to see that it was opened correctly */
  i=strlen(datout);
  strcpy (&datout[i], ".msh");
  handle1 = fopen (datout, "w+b");
  if (handle1==NULL) { printf ("\nThe output file \"%s\" could not be opened.\n\n",
     datout); exit(-1);}
  else  printf (" file %s opened\n",datout);

  strcpy (&datout[i], ".temp");
  handle2 = fopen (datout, "w+b");
  if (handle2==NULL) { printf ("\nThe output file \"%s\" could not be opened.\n\n",
     datout); exit(-1);}
  else  printf (" file %s opened\n",datout);

  printf (" write abaqus data \n");

    fprintf (handle1, "*NODE, NSET=N%s\n", anz->model);
    for (i=0; i<anz->n; i++)
      {
      fprintf (handle1, "%8d, %12.5e, %12.5e, %12.5e \n", node[i].nr, node[node[i].nr].nx,
      node[node[i].nr].ny, node[node[i].nr].nz);
      }

  for (i=0; i<anz->e; i++)
  {
    if (elem[i].type == 1)
    {
      if (((i>0)&&(elem[i-1].type) != elem[i].type)||(i==0))
      {
        if (elem[i].attr==2)  fprintf (handle1, "*ELEMENT, TYPE=C3D8I, ELSET=E%s\n", anz->model);
        else if (elem[i].attr==1) fprintf (handle1, "*ELEMENT, TYPE=C3D8R, ELSET=E%s\n", anz->model);
        else                 fprintf (handle1, "*ELEMENT, TYPE=C3D8, ELSET=E%s\n", anz->model);
      }
      fprintf (handle1, "%6d,%6d,%6d,%6d,%6d,%6d,%6d,%6d,%6d\n",
        elem[i].nr, elem[i].nod[0], elem[i].nod[1], elem[i].nod[2],
        elem[i].nod[3], elem[i].nod[4], elem[i].nod[5], elem[i].nod[6], elem[i].nod[7]);
    }
    else if (elem[i].type == 2)
    {
      if (((i>0)&&(elem[i-1].type) != elem[i].type)||(i==0))
      {
        fprintf (handle1, "*ELEMENT, TYPE=C3D6, ELSET=E%s\n", anz->model);
      }
      fprintf (handle1, "%6d,%6d,%6d,%6d,%6d,%6d,%6d\n",
        elem[i].nr, elem[i].nod[0], elem[i].nod[1], elem[i].nod[2],
        elem[i].nod[3], elem[i].nod[4], elem[i].nod[5]);
    }
    else if (elem[i].type == 3)
    {
      if (((i>0)&&(elem[i-1].type) != elem[i].type)||(i==0))
      {
        fprintf (handle1, "*ELEMENT, TYPE=C3D4, ELSET=E%s\n", anz->model);
      }
      fprintf (handle1, "%6d,%6d,%6d,%6d,%6d \n",
        elem[i].nr, elem[i].nod[0], elem[i].nod[1], elem[i].nod[2],
        elem[i].nod[3]);
    }
    else if (elem[i].type == 4)
    {
      if (((i>0)&&(elem[i-1].type) != elem[i].type)||(i==0))
      {
        if (elem[i].attr==1) fprintf (handle1, "*ELEMENT, TYPE=C3D20R, ELSET=E%s\n", anz->model);
        else            fprintf (handle1, "*ELEMENT, TYPE=C3D20, ELSET=E%s\n", anz->model);
      }
      fprintf (handle1, "%6d,%6d,%6d,%6d,%6d,%6d,%6d,%6d,%6d,%6d,%6d,\n",
        elem[i].nr, elem[i].nod[0], elem[i].nod[1], elem[i].nod[2],
        elem[i].nod[3], elem[i].nod[4], elem[i].nod[5], elem[i].nod[6],
        elem[i].nod[7], elem[i].nod[8], elem[i].nod[9]);
      fprintf (handle1, "      %6d,%6d,%6d,%6d,%6d,%6d,%6d,%6d,%6d,%6d\n",
        elem[i].nod[10], elem[i].nod[11], elem[i].nod[16], elem[i].nod[17],
        elem[i].nod[18], elem[i].nod[19], elem[i].nod[12], elem[i].nod[13],
        elem[i].nod[14], elem[i].nod[15] );
    }
    else if (elem[i].type == 5)
    {
      if (((i>0)&&(elem[i-1].type) != elem[i].type)||(i==0))
      {
        fprintf (handle1, "*ELEMENT, TYPE=C3D15, ELSET=E%s\n", anz->model);
      }
      fprintf (handle1, "%6d,%6d,%6d,%6d,%6d,%6d,%6d,%6d,%6d,%6d\n",
        elem[i].nr, elem[i].nod[0], elem[i].nod[1], elem[i].nod[2],
        elem[i].nod[3], elem[i].nod[4], elem[i].nod[5], elem[i].nod[6],
        elem[i].nod[7], elem[i].nod[8]);
      fprintf (handle1, "      %6d,%6d,%6d,%6d,%6d,%6d\n",
        elem[i].nod[12], elem[i].nod[13], elem[i].nod[14], elem[i].nod[9],
        elem[i].nod[10], elem[i].nod[11] );
    }
    else if (elem[i].type == 6)
    {
      if (((i>0)&&(elem[i-1].type) != elem[i].type)||(i==0))
      {
        fprintf (handle1, "*ELEMENT, TYPE=C3D10, ELSET=E%s\n", anz->model);
      }
      fprintf (handle1, "%6d,%6d,%6d,%6d,%6d,%6d,%6d,%6d,%6d,%6d,%6d \n",
        elem[i].nr, elem[i].nod[0], elem[i].nod[1], elem[i].nod[2],
        elem[i].nod[3], elem[i].nod[4], elem[i].nod[5], elem[i].nod[6],
        elem[i].nod[7], elem[i].nod[8], elem[i].nod[9]);
    }
    else if (elem[i].type == 7)
    {
      if (((i>0)&&(elem[i-1].type) != elem[i].type)||(i==0))
      {
        fprintf (handle1, "*ELEMENT, TYPE=S3R, ELSET=E%s\n", anz->model);
      }
      fprintf (handle1, "%6d,%6d, %6d, %6d \n",
        elem[i].nr, elem[i].nod[0], elem[i].nod[1], elem[i].nod[2] );
    }
    else if (elem[i].type == 8)
    {
      if (((i>0)&&(elem[i-1].type) != elem[i].type)||(i==0))
      {
        fprintf (handle1, "*ELEMENT, TYPE=STRI65, ELSET=E%s\n", anz->model);
      }
      fprintf (handle1, "%6d, %6d, %6d, %6d, %6d, %6d, %6d\n",
        elem[i].nr, elem[i].nod[0], elem[i].nod[1], elem[i].nod[2],
        elem[i].nod[3], elem[i].nod[4], elem[i].nod[5]);
    }
    else if (elem[i].type == 9)
    {
      if (((i>0)&&(elem[i-1].type) != elem[i].type)||(i==0))
      {
        fprintf (handle1, "*ELEMENT, TYPE=S4, ELSET=E%s\n", anz->model);
      }
      fprintf (handle1, "%6d, %6d, %6d, %6d, %6d\n",
        elem[i].nr, elem[i].nod[0], elem[i].nod[1], elem[i].nod[2],
        elem[i].nod[3]);
    }
    else if (elem[i].type == 10)
    {
      if (((i>0)&&(elem[i-1].type) != elem[i].type)||(i==0))
      {
        fprintf (handle1, "*ELEMENT, TYPE=S8, ELSET=E%s\n", anz->model);
      }
      fprintf (handle1, "%6d, %6d, %6d, %6d, %6d, %6d, %6d, %6d, %6d\n"
      , elem[i].nr, elem[i].nod[0], elem[i].nod[1], elem[i].nod[2], elem[i].nod[3]
      , elem[i].nod[4], elem[i].nod[5], elem[i].nod[6], elem[i].nod[7]);
    }
    else if (elem[i].type == 11)
    {
      if (((i>0)&&(elem[i-1].type) != elem[i].type)||(i==0))
      {
        fprintf (handle1, "*ELEMENT, TYPE=B31, ELSET=E%s\n", anz->model);
      }
      fprintf (handle1, "%6d, %6d, %6d\n",
        elem[i].nr, elem[i].nod[0], elem[i].nod[1] );
    }
    else if (elem[i].type == 12)
    {
      if (((i>0)&&(elem[i-1].type) != elem[i].type)||(i==0))
      {
        fprintf (handle1, "*ELEMENT, TYPE=B32, ELSET=E%s\n", anz->model);
      }
      fprintf (handle1, "%6d, %6d, %6d, %6d\n",
        elem[i].nr, elem[i].nod[0], elem[i].nod[2], elem[i].nod[1] );
    }
    else
    {
      printf (" WARNING: elem(%d) not a known type (%d)\n", elem[i].nr, elem[i].type);
    }
  }

  j=0;
  for (lc=0; lc<anz->l; lc++)
  {
    if (lcase[lc].ncomps == 1)
    {
      j++;
      if(anz->l>1)
      {
        fprintf (handle2, "** ---  LC%d ---\n", j);
        fprintf (handle2, "*STEP\n");
        fprintf (handle2, "*STATIC\n");
        fprintf (handle2, "*TEMPERATURE\n");
      }
      for (i=0; i<anz->n; i++)
      {
        fprintf (handle2, "%8d, %12.5f\n", node[i].nr,
        lcase[lc].dat[0][node[i].nr]);
      }
      
      if(anz->l>1)
      {
        fprintf (handle2, "*NODE PRINT, FREQUENCY=0 \n");
        fprintf (handle2, "*EL PRINT, FREQUENCY=0 \n");
        fprintf (handle2, "*NODE FILE\n");
        fprintf (handle2, "U, NT \n");
      
        fprintf (handle2, "*EL FILE,POSITION=AVERAGED AT NODES\n");
        fprintf (handle2, "S \n");
        fprintf (handle2, "*END STEP\n");
      }
    }
  }

  fclose(handle1);
  fclose(handle2);
  return (1);
}

