// libSNL - Simple Nurbs Library
// Copyright Scott A.E. Lanham, Australia.
// ---------------------------------------
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Library General Public License for more details.
//
//  You should have received a copy of the GNU Library General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

// *** Small Utility Classes and Functions ***

#ifndef SNLUTIL_H
#define SNLUTIL_H

#include "snlPoint.h"
#include "snlVector.h"

#ifdef SGI_MIPS

    #include <iostream.h>
    #include <math.h>
    
#else

    #include <iostream>
    #include <cmath>
    
    using namespace std;
    
#endif

const int MAX_BINOMIAL = 64;  // Maximum binomial array dimension.

class binCoefs
{
    // Generate a static array of Binomial Coefficients
    // Array structure is [k][i] where k! / i! ( k - i )!.

    public:

        static int  binCoefArray [ MAX_BINOMIAL ] [ MAX_BINOMIAL ];

        binCoefs();
};

double distToLine ( snlPoint lineStart, snlPoint lineEnd, snlPoint compare );
snlVector projectToLine ( snlPoint lineStart, snlPoint lineEnd, snlPoint compare );

#endif
